<template>
  <div>
    <v-app id="login" class="primary">
      <v-content>
        <v-container fluid fill-height>
          <v-layout align-center justify-center>
            <v-flex xs12 sm6 md6 lg3>
              <v-card class="elevation-1 pa-3">
                <v-card-text>
                  <div class="layout column align-center">
                    <h1 class="flex my-2 primary--text">Buisek</h1>
                  </div>
                  <v-form v-model="valid">
                    <v-text-field
                      v-model="formdata.name"
                      v-validate="'required'"
                      append-icon="person"
                      name="name"
                      label="Nombre"
                      type="text"
                      required
                    ></v-text-field>
                    <v-text-field
                      id="dni"
                      v-model="formdata.dni"
                      v-validate="'required'"
                      append-icon="lock"
                      name="dni"
                      label="Dni"
                      type="text"
                      required
                    ></v-text-field>
                  </v-form>
                </v-card-text>
                <v-card-actions>
                  <v-btn block color="primary" :loading="loading" @click="onLoginSubmit">Entrar</v-btn>
                </v-card-actions>
              </v-card>
            </v-flex>
          </v-layout>
        </v-container>
      </v-content>
    </v-app>
    <v-snackbar v-model="snackbar.show" :timeout="3000" top right :color="snackbar.color">
      {{ snackbar.text }}
      <v-btn dark flat icon @click.native="snackbar.show = false">
        <v-icon>close</v-icon>
      </v-btn>
    </v-snackbar>
  </div>
</template>

<script>
import _ from "lodash";
import AppEvents from "@/event";
export default {
  name: "Login",
  data: () => ({
    formdata: {
      dni: null,
      name: null
    },
    isError: false,
    info: null,
    loading: false,
    valid: true,
    snackbar: {
      show: false,
      text: "",
      color: "red"
    },
    votes: []
  }),
  created() {
    AppEvents.forEach(item => {
      this.$on(item.name, item.callback);
    });
    window.getApp = this;
  },
  computed: {},
  mounted() {
    this.info = this.$route.params.info;
  },
  methods: {
    onLoginSubmit() {
      this.loading = true;

      if (this.validateForm()) {
        window.getApp.$emit("APP_AUTH_FAILED");
        this.loading = false;
        return;
      }
      localStorage.clear();
      this.$store
        .dispatch("GET_AUTH_TOKEN", this.formdata)
        .then(response => {
          let self = this;
          let _isVote = _.find(self.$store.getters.getVotes, function(i) {
            return i.dni === self.formdata.dni;
          });
          
          if (_isVote) {             
            localStorage.setItem("voted", true);
            this.$router.go("/dashboard");
          } else {
            this.$router.go("/votes");
          }
        })
        .catch(e => {
          this.loading = false;
          this.isError = true;
          window.getApp.$emit("APP_AUTH_FAILED");
        });
    },
    validateForm() {
      let valid = false;
      if (!this.formdata.name) {
        valid = true;
      }
      if (!this.formdata.dni) {
        valid = true;
      }
      return valid;
    }
  }
};
</script>
<style scoped lang="css">
#login {
  height: 50%;
  width: 100%;
  position: absolute;
  top: 0;
  left: 0;
  content: "";
  z-index: 0;
}
.primary {
  background-color: #005ed3 !important;
  border-color: #1976d2 !important;
}
</style>
